import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import CaptionModular from './captionModular';
import { event } from '../../eventbus';
import { TemDataModule } from '../../../../helper/index';
import CaptionCollection from '../../PropsCollection/CaptionCollection';
import axios from 'axios';
import { getCloudApiUrl } from '../../../../helper/getCloudApi';
import { GetQueryString } from '../../../../helper/requireURLid';
import produce from 'immer';
import './index.css';
export var Temp = new TemDataModule();

var CaptionComponent =
/*#__PURE__*/
function (_Component) {
  _inherits(CaptionComponent, _Component);

  function CaptionComponent(props) {
    var _this;

    _classCallCheck(this, CaptionComponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CaptionComponent).call(this, props));
    _this.state = {
      components: [{
        title: '',
        list: []
      }],
      urlData: '',
      mobileData: '',
      show: true
    };

    _this.hanleClick = function (val, e) {
      var timer = null;
      clearTimeout(timer);
      var urlData = _this.state.urlData;
      urlData && urlData.componentList.map(function (item, index) {
        if (val.key === item.key) {
          timer = setTimeout(function () {
            event.emit('change', {
              index: index,
              key: val.key
            }); //触发这个事件
          }, 50);
        }

        ;
      });
    };

    _this.handleUrl = function () {
      var url = "/CompensationMRest/100000/SalaryPlan/GetPaySlipPageBuilderData?id=".concat(GetQueryString('dataId'));
      axios(getCloudApiUrl(url), {
        method: 'GET',
        headers: {
          "Content-Type": "application/json",
          "accept": 'application/json'
        },
        mode: 'no-cors',
        withCredentials: true
      }).then(function (res) {
        if (res.data.Code == 0) {
          var num = sessionStorage.getItem('num');
          sessionStorage.setItem('num', ++num);
          var data = res.data.Data;
          data.componentList.map(function (item, index) {
            item.key = index;
          });

          _this.setState({
            urlData: data
          }, function () {
            Temp.set(data);
          });
        }
      });
    };

    _this.getTitleItemCssClasses = function (index) {
      return index === _this.state.currentIndex ? "caption-modular caption-modular-show" : "caption-modular";
    };

    _this.getMoblieData = function () {
      var url = "/CompensationMRest/100000/Payrolls/MobileGetPayrollsDetail?dataId=".concat(GetQueryString('dataId'));
      axios(getCloudApiUrl(url), {
        method: 'GET',
        headers: {
          "Content-Type": "application/json",
          "accept": 'application/json'
        },
        mode: 'no-cors',
        withCredentials: true
      }).then(function (res) {
        if (res.data.Code === 0) {
          _this.setState({
            mobileData: res.data.Data
          });
        } else if (res.data.Code === 417) {
          _this.setState({
            show: false
          });
        }
      });
    };

    return _this;
  }

  _createClass(CaptionComponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      sessionStorage.setItem('num', 0); //请求自定义属性配置

      this.handleUrl();

      if (/Android|webOS|iPhone|iPod|BlackBerry/i.test(navigator.userAgent)) {
        this.getMoblieData();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      var num = sessionStorage.getItem('num');

      if (num > 1) {
        this.setState({
          urlData: nextProps.data.CaptionCollection
        }, function () {
          Temp.set(_this2.state.urlData);
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var mode = this.props.mode;
      var _this$state = this.state,
          mobileData = _this$state.mobileData,
          show = _this$state.show;
      var newdata = {};

      if (mode == "2") {
        newdata = this.state.urlData.componentList;
      } //预览模式


      if (mode == "3") {
        newdata = !this.props.data.CaptionCollection.componentList ? this.state.urlData.componentList : this.props.data.CaptionCollection.componentList;
      }

      newdata = /Android|webOS|iPhone|iPod|BlackBerry/i.test(navigator.userAgent) && mobileData ? mobileData.componentList : newdata;
      return show ? React.createElement("div", {
        className: "caption-wrap"
      }, newdata && newdata.map(function (item, index) {
        return React.createElement(CaptionModular, {
          data: item,
          key: 'Item' + index,
          handleClick: _this3.hanleClick,
          mode: mode,
          index: index
        });
      })) : null;
    }
  }], [{
    key: "getEditProps",
    value: function getEditProps() {
      return [{
        pType: CaptionCollection,
        name: '',
        key: 'CaptionCollection'
      }];
    }
  }]);

  return CaptionComponent;
}(Component);

CaptionComponent.displayTitle = '标题组件';
export { CaptionComponent as default };