import "core-js/modules/es6.regexp.search";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import './index.css';
import CaptionTitle from './CaptionTitle';
import CaptionSelected from './CaptionSelected';
import CaptionProject from './CaptionProject';
import produce from "immer";
import ToolTip from '@beisen/tool-tip';
import { event } from '../../eventbus';
import axios from 'axios';
import { getCloudApiUrl } from '../../../../helper/getCloudApi';
import { GetQueryString } from '../../../../helper/requireURLid';
import { Temp } from '../../ElementCollection/CaptionComponent/index';

var CaptionCollection =
/*#__PURE__*/
function (_Component) {
  _inherits(CaptionCollection, _Component);

  function CaptionCollection(props) {
    var _this;

    _classCallCheck(this, CaptionCollection);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CaptionCollection).call(this, props));
    _this.view = {
      componentList: [{
        "title": "基本工资",
        "list": [{
          "text": "基本工资",
          "value": 0.0,
          "key": "BasicSalary",
          "eyeState": "0"
        }]
      }],
      attrList: [{
        text: '养老保险',
        value: '00.00',
        eyeState: "1",
        key: 1,
        checked: false
      }]
    };
    _this.state = {
      search: [],
      val: '',
      inputValue: '',
      urlData: ''
    };

    _this.handleUrl = function () {
      _this.setState({
        urlData: Temp.get()
      }, function () {
        _this.props.update(_this.state.urlData);
      });
    };

    _this.hanleClose = function (item, e) {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var _this$state = _this.state,
          val = _this$state.val,
          urlData = _this$state.urlData;
      var value = val === '' ? 0 : val;
      var nextState = produce(_this.state, function (draftState) {
        var urldata = draftState.urlData;
        urldata.attrList.map(function (lists, index) {
          if (lists.key === item.key) {
            lists.checked = !lists.checked;
            urldata.componentList[value].list.map(function (items, index) {
              if (items.key === lists.key) {
                urldata.componentList[value].list.splice(index, 1);
              }
            });
          }
        });
      });

      _this.setState({
        urlData: nextState.urlData
      }, function () {
        _this.props.update(_this.state.urlData);
      });
    };

    _this.handleSelcted = function (item, e) {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var _this$state2 = _this.state,
          search = _this$state2.search,
          val = _this$state2.val,
          urlData = _this$state2.urlData;
      var value = val === '' ? 0 : val;
      var nextState = produce(_this.state, function (draftState) {
        var urldata = draftState.urlData;
        urldata.attrList.map(function (newdata, index) {
          newdata.checked = false;
          urldata.componentList[value].list.map(function (list, index) {
            if (list.key === newdata.key) {
              newdata.checked = true;
            }
          });

          if (newdata.key === item.key) {
            newdata.checked = !newdata.checked;

            if (newdata.checked === true) {
              urldata.componentList[value].list.push(newdata);
            } else {
              urldata.componentList[value].list.map(function (items, index) {
                items.key === newdata.key ? urldata.componentList[value].list.splice(index, 1) : '';
              });
            }
          }
        });
      });
      var nextSearch = produce(_this.state, function (draftSearch) {
        draftSearch.search.map(function (newSearch, index) {
          item.key === newSearch.key ? newSearch.checked = !newSearch.checked : '';
        });
      });

      _this.setState({
        search: nextSearch.search,
        urlData: nextState.urlData
      }, function () {
        _this.props.update(_this.state.urlData);
      });
    };

    _this.handleUp = function (i, e) {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var _this$state3 = _this.state,
          val = _this$state3.val,
          urlData = _this$state3.urlData;
      var value = val === '' ? 0 : val;
      var nextState = produce(_this.state, function (draftState) {
        var newData = draftState.urlData.componentList[value].list;
        var k = i === 0 ? i + 1 : i - 1;
        newData[i] = newData.splice(k, 1, newData[i])[0];
      });

      _this.setState({
        urlData: nextState.urlData
      }, function () {
        _this.props.update(_this.state.urlData);
      });
    };

    _this.hanleEyeStatus = function (i, e) {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var _this$state4 = _this.state,
          val = _this$state4.val,
          urlData = _this$state4.urlData;
      var indexValue = val === '' ? 0 : val;
      var nextState = produce(_this.state, function (draftState) {
        draftState.urlData.componentList[indexValue].list.map(function (item, index) {
          item.checked = true;
          index === i && item.value == 0 ? item.eyeState = item.eyeState === "1" ? "0" : "1" : '';
        });
      });

      _this.setState({
        urlData: nextState.urlData
      }, function () {
        _this.props.update(_this.state.urlData);
      });
    };

    _this.hanleInsert = function () {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var urlData = _this.state.urlData;
      var nextState = produce(_this.state, function (draftState) {
        draftState.urlData.componentList.push({
          title: "",
          list: [],
          key: draftState.urlData.componentList.length
        });
      });

      _this.setState({
        urlData: nextState.urlData
      }, function () {
        _this.props.update(_this.state.urlData);
      });
    };

    _this.handleDelete = function () {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var update = _this.props.update;
      var _this$state5 = _this.state,
          val = _this$state5.val,
          urlData = _this$state5.urlData;
      var nextState = produce(_this.state, function (draftState) {
        if (draftState.urlData.componentList.length === 1) {
          return;
        }

        draftState.urlData.componentList.splice(val, 1);
      });

      _this.setState({
        urlData: nextState.urlData
      }, function () {
        update(_this.state.urlData);
      });
    };

    _this.handleChange = function (e) {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var update = _this.props.update;
      var _this$state6 = _this.state,
          val = _this$state6.val,
          urlData = _this$state6.urlData;
      var value = val === "" ? 0 : val;
      var nextState = produce(_this.state, function (draftState) {
        draftState.urlData.componentList[value].title = e.target.value;
      });

      _this.setState({
        urlData: nextState.urlData,
        inputValue: e.target.value
      }, function () {
        update(_this.state.urlData);
      });
    };

    _this.handleBlur = function (e) {};

    _this.handleSearch = function (e) {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var _this$state7 = _this.state,
          val = _this$state7.val,
          urlData = _this$state7.urlData;
      var value = e.target.value;
      var search = [];
      var data = urlData.attrList;
      var indexValue = val === '' ? 0 : val;

      for (var i = 0; i < data.length; i++) {
        data && data[i] && data[i].text && data[i].text.indexOf(value) > -1 ? search.push(data[i]) : '';
      }

      _this.setState({
        search: search
      });
    };

    _this.handleFocus = function () {
      var num = sessionStorage.getItem('num');
      sessionStorage.setItem('num', ++num);
      var _this$state8 = _this.state,
          val = _this$state8.val,
          urlData = _this$state8.urlData;
      var value = val === '' ? 0 : val;

      _this.setState({
        inputValue: urlData.componentList[value].title
      });
    };

    _this.handleInputData = function () {
      var _this$state9 = _this.state,
          val = _this$state9.val,
          urlData = _this$state9.urlData;
      var value = val === '' ? 0 : val;

      if (value === '') {
        return;
      } else {
        _this.setState({
          inputValue: urlData.componentList[value].title
        });
      }
    };

    _this.handleData = function () {
      var _this$state10 = _this.state,
          urlData = _this$state10.urlData,
          val = _this$state10.val;
      var value = val === '' ? '' : val;
      var componentList = urlData.componentList;
      return !urlData ? _this.view.attrList : val === '' ? _this.state : produce(_this.state, function (draftDate) {
        draftDate.urlData.attrList.map(function (item, index) {
          item.checked = false;
          var value = val === '' ? 0 : !componentList[val] ? val - 1 : val;
          componentList[value] && componentList[value].list.map(function (lists, index) {
            if (lists.key === item.key) {
              if (item.checked === false) {
                item.checked = true;
              }
            }
          });
        });
      });
    };

    return _this;
  }

  _createClass(CaptionCollection, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.props.update(Temp.get());
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      //在组件挂载完成后声明一个自定义事件
      //获取接口中的数据
      this.handleUrl();
      var that = this; //先去除监听自定义监听事件

      event.removeAllListeners("change"); //绑定监听事件，监听change，返回对应的key值和index值，（index值并没有用到，考虑删除）

      event.addListener('change', function (item, index) {
        var urlData = that.state.urlData;
        var attrList = urlData.attrList,
            componentList = urlData.componentList;
        var component = !urlData ? that.props.data : urlData; //循环标题组件中的数据,返回对应的index，即val值

        var nextIndex = produce(that.state, function (draftIndex) {
          component.componentList.map(function (items, index) {
            if (items.key === item.key) {
              draftIndex.val = index;
            }
          });
        });
        that.setState({
          val: nextIndex.val
        }, function () {
          _this2.handleInputData();
        });
      });
    } //组件卸载时，移除监听事件

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      event.removeAllListeners("change"); //属性组件卸载的时候，调用接口保存数据  
    } //判断是否存在this.props，若没有，则从接口中获取制定数据，并更新state值，若有直接使用this.props.data中的值

  }, {
    key: "render",
    value: function render() {
      var _this$state11 = this.state,
          search = _this$state11.search,
          val = _this$state11.val,
          inputValue = _this$state11.inputValue,
          urlData = _this$state11.urlData;
      var componentList = urlData.componentList;
      var newDate = this.handleData();
      var test = !urlData ? this.view.attrList : newDate.urlData.attrList;
      var componentData = val === "" ? '' : !componentList[val] ? componentList[val - 1] : componentList[val];
      var list = !componentData ? '' : componentData.list;
      return React.createElement("div", {
        className: "caption-wraper"
      }, React.createElement(CaptionTitle, {
        handleChange: this.handleChange,
        handleBlur: this.handleBlur,
        value: inputValue,
        handleFocus: this.handleFocus
      }), React.createElement(CaptionProject, {
        data: test,
        update: this.props.update,
        handleSelcted: this.handleSelcted,
        handleSearch: this.handleSearch,
        search: search
      }), React.createElement(CaptionSelected, {
        list: list,
        update: this.props.update,
        hanleClose: this.hanleClose,
        handleUp: this.handleUp,
        hanleEyeStatus: this.hanleEyeStatus
      }), React.createElement("div", {
        className: "caption-bottom"
      }, React.createElement("div", {
        className: "caption-insert",
        onClick: this.hanleInsert
      }, "\u65B0\u589E\u6807\u9898"), React.createElement("div", {
        className: "caption-delete",
        onClick: this.handleDelete
      }, "\u5220\u9664")));
    }
  }]);

  return CaptionCollection;
}(Component);

export { CaptionCollection as default };